#include <iostream>
#include <cmath>

using namespace std;
string krvna_grupa;
int main()
{
    int y,bro=0,bra=0,brb=0,brab=0;
    int o,a,b,ab;
    int n;
    cin>>n;

    int k1,k2,k3,k4;
    cin>>k1>>k2>>k3>>k4;

    for(int k=0; k<n; k++){
        cin>>krvna_grupa>>y;
        if(krvna_grupa=="O")bro+=y;
        if(krvna_grupa=="A")bra+=(y+bro);
        if(krvna_grupa=="B")brb+=(y+bro);
        brab+=y;
    }

    if(k1<bro){
        cout<<"nemoguce"<<'\n';
        goto kraj;
    }else{
        k1=k1-bro;

    }

    if((k2+k1)<(bra-bro)){
        cout<<"nemoguce"<<'\n';
        goto kraj;
    }else{
        k2=(k2+k1)-(bra-bro);

    }

    if((k3+k1)<(brb-bro)){
        cout<<"nemoguce"<<'\n';
        goto kraj;
    }else{
        k3=(k3+k1)-(brb-bro);

    }

    if((k4+k2+k3+k1)<(brab-brb-bro-bra)){
        cout<<"nemoguce"<<'\n';
        goto kraj;
    }else{
        k4=(k4+k2+k3+k1)-(brab-bro-bra-brb);

    }

    cout<<"moguce"<<'\n';
kraj:

    o=k1-bro;
    a=(k2+k1)-bra;
    b=(k3+k1)-brb;
    ab=(k3+k4+k2+k1)-brab;
    for(int i=0; i<n; i++){
        cout<<o<<" "<<a<<" "<<b<<" "<<ab<<'\n';
    }
    return 0;
}